"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_webview_1 = require("react-native-webview");
const FrontFinance = (props) => {
    const isDarkMode = (react_native_1.useColorScheme === null || react_native_1.useColorScheme === void 0 ? void 0 : (0, react_native_1.useColorScheme)()) === 'dark';
    const backgroundStyle = {
        backgroundColor: isDarkMode ? '#000000' : '#ffffff'
    };
    const [catalogLink, setCatalogLink] = (0, react_1.useState)(null);
    const [showWebView, setShowWebView] = (0, react_1.useState)(false);
    const [showNativeNavbar, setShowNativeNavbar] = (0, react_1.useState)(false);
    const webViewRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        var _a;
        if (props.url.length) {
            setCatalogLink(props.url);
            setShowWebView(true);
        }
        else {
            (_a = props.onError) === null || _a === void 0 ? void 0 : _a.call(props, 'Invalid iframeUrl');
        }
        return () => {
            setCatalogLink(null);
            setShowWebView(false);
        };
    }, [props]);
    const handleNavState = (event) => {
        if (event.url.endsWith('/broker-connect/catalog')) {
            setShowNativeNavbar(false);
        }
    };
    const handleMessage = (event) => {
        var _a, _b, _c, _d;
        const { type, payload } = JSON.parse(event.nativeEvent.data);
        if (type === 'close' || type === 'done') {
            (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
        }
        if (type === 'showClose') {
            showCloseAlert();
        }
        if (type === 'showNativeNavbar') {
            setShowNativeNavbar(payload);
        }
        if (type === 'brokerageAccountAccessToken') {
            (_b = props.onBrokerConnected) === null || _b === void 0 ? void 0 : _b.call(props, { accessToken: payload });
        }
        if (type === 'delayedAuthentication') {
            (_c = props.onBrokerConnected) === null || _c === void 0 ? void 0 : _c.call(props, { delayedAuth: payload });
        }
        if (type === 'transferFinished') {
            (_d = props.onTransferFinished) === null || _d === void 0 ? void 0 : _d.call(props, payload);
        }
    };
    const goBack = () => { var _a; return (_a = webViewRef === null || webViewRef === void 0 ? void 0 : webViewRef.current) === null || _a === void 0 ? void 0 : _a.goBack(); };
    const showCloseAlert = () => react_native_1.Alert.alert('Are you sure you want to exit?', 'Your progress will be lost.', [
        {
            text: 'Cancel',
            style: 'cancel'
        },
        { text: 'Exit', onPress: () => { var _a; return (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props); } }
    ]);
    return (<react_native_1.SafeAreaView style={{ flex: 1 }}>
      <react_native_1.StatusBar barStyle={isDarkMode ? 'light-content' : 'dark-content'} backgroundColor={backgroundStyle.backgroundColor}/>
      {showNativeNavbar && (<react_native_1.View style={styles.navBarContainer}>
          <react_native_1.TouchableOpacity onPress={goBack} style={styles.navBarImgContainer}>
            <react_native_1.Image source={require('@front-finance/frontfinance-rn-sdk/assets/ic_back.png')} style={styles.navBarImgButton}/>
          </react_native_1.TouchableOpacity>

          <react_native_1.Image source={require('@front-finance/frontfinance-rn-sdk/assets/front_logo.png')} style={styles.navBarLogo}/>

          <react_native_1.TouchableOpacity onPress={showCloseAlert} style={styles.navBarImgContainer}>
            <react_native_1.Image source={require('@front-finance/frontfinance-rn-sdk/assets/ic_close.png')} style={styles.navBarImgButton}/>
          </react_native_1.TouchableOpacity>
        </react_native_1.View>)}
      {showWebView && catalogLink && (<react_native_webview_1.WebView ref={webViewRef} source={{ uri: catalogLink ? catalogLink : '' }} onMessage={handleMessage} javaScriptEnabled={true} onNavigationStateChange={handleNavState}/>)}
    </react_native_1.SafeAreaView>);
};
const styles = react_native_1.StyleSheet.create({
    navBarContainer: {
        flexDirection: 'row',
        justifyContent: 'space-between',
        alignItems: 'center',
        height: 64,
        paddingTop: 12,
        paddingStart: 6,
        paddingEnd: 8
    },
    navBarImgContainer: {
        width: 40,
        height: 40,
        alignItems: 'center',
        justifyContent: 'center'
    },
    navBarImgButton: {
        width: 24,
        height: 24,
        resizeMode: 'contain'
    },
    navBarLogo: {
        height: 18,
        resizeMode: 'contain'
    }
});
exports.default = FrontFinance;
